﻿package com{
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	
	public class blank100Square extends MovieClip{		
		private var gridsMC:MovieClip;		
		private var gridBox:gridBoxMc;
		private var X:Number = 10;
		private var Y:Number = 10;
		private var stageWidth:Number = 760;
		private var gridBoxX:Number = 250;
		private var gridBoxY:Number = 5;
		private var count:Number = 0;
		private var mcColorTransform:ColorTransform;
		private var colorArr:Array = ["0x40AF49", "0xed1c24", "0xffdd00", "0x005fae"];
		private var tickPosArr:Array = ["208_95", "208_202", "208_286"];
		private var color:uint = 0xffdd00;
		private var clrShadGridCnt:Number = 0;
		private var prevClip:MovieClip;
		private var tickMCs:MovieClip = new MovieClip;
		private var isDoubleClicked:Boolean = false;
		
		public function blank100Square():void{
			addChild(tickMCs);		
			fnGenerateGrids();
			for(var i:Number = 0; i < colorArr.length; i++){
				var colorClip:SimpleButton = colorPalette_mc.getChildByName("clr_" + i + "_mc") as SimpleButton;
				var mc=colorPalette_mc.getChildByName("hi" + i);
				mc.visible=false;
				colorClip.addEventListener(MouseEvent.CLICK, fnChangeGridColorCode);
			}
			mc = colorPalette_mc.getChildByName("hi2");
			mc.visible=true;
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
			hidePercentBtn.showPerTxt_mc.addEventListener(MouseEvent.CLICK, fnShowHidePercentage);
			hidePercentBtn.hidePerTxt_mc.addEventListener(MouseEvent.CLICK, fnShowHidePercentage);
			//hidePercentBtn.mouseChildren = false;
			hidePercentBtn.buttonMode = true;
			hidePercentBtn.showPerTxt_mc.visible = false;
			/*showNoBtn.showNoTxt_mc.addEventListener(MouseEvent.CLICK, fnShowNoInGrid);
			showNoBtn.hideNoTxt_mc.addEventListener(MouseEvent.CLICK, fnShowNoInGrid);
			//showNoBtn.mouseChildren = false;
			showNoBtn.buttonMode = true;
			showNoBtn.hideNoTxt_mc.visible = false;*/
			randomShadeBtn.addEventListener(MouseEvent.CLICK, fnRandomShadeGrid);
			//autoShadeBtn.addEventListener(MouseEvent.CLICK, fnAutoShadeGrid);
			
			//characters restriction
			numTxt.restrict="0-9";
			denTxt.restrict="0-9";
			decimalTxt.restrict="0-9.";
			percent_mc.percentTxt.restrict="0-9";
			percent_mc.percentTxt.maxChars=3;
			numTxt.addEventListener(Event.CHANGE, fnValidate);
			denTxt.addEventListener(Event.CHANGE, fnValidate);
			decimalTxt.addEventListener(Event.CHANGE, fnValidate);
			percent_mc.percentTxt.addEventListener(Event.CHANGE, fnValidate);
			numTxt.tabIndex=0;
			denTxt.tabIndex=1;
			decimalTxt.tabIndex=2
			percent_mc.percentTxt.tabIndex=3;
		}
		
		//Generates grid 
		private function fnGenerateGrids():void{
			gridsMC = new MovieClip();
			addChild(gridsMC);
			count = 1;
			for(var i:Number = 1; i <= 10; i++){				
				for(var j:Number = 1; j <= 10; j++){
					gridBox = new gridBoxMc;
					gridsMC.addChild(gridBox);					
					gridBox.name = "gridBox_" + count;
					gridBox.numberTxt.text = String(count);
					gridBox.numberTxt.visible = false;
					mcColorTransform = gridBox.transform.colorTransform;
					mcColorTransform.color = 0xffffff;	
					gridBox.gridBoxBgMC.transform.colorTransform = mcColorTransform;
					gridBox.mouseChildren = false;
					gridBox.doubleClickEnabled = true;
					gridBox.tabEnabled = false;
					gridBox.addEventListener(MouseEvent.MOUSE_DOWN, fnChngClickGridColor);
					gridBox.addEventListener(MouseEvent.DOUBLE_CLICK, fnChngClickGridColorDC);
					if((i == 1 && j == 1) || (j == 1)){
						if(i == 1 && j == 1){
							gridBox.x = X;
							gridBox.y = Y;
						}else{
							gridBox.x = 10;
							gridBox.y = Y;
						}
						
					}else{
						X = X + gridBox.width - 2;
						gridBox.x = X;
						gridBox.y = Y;
					}
					count++;
				}
				Y = Y + gridBox.height - 2
				X = 10;
			}
			count--;
			gridsMC.x = gridBoxX;
			gridsMC.y = gridBoxY;
		}
		
		//removing color on double click
		private function fnChngClickGridColorDC(eve:MouseEvent):void{
			var gridClip:MovieClip = eve.target as MovieClip;
			isDoubleClicked = true;
			fnChangeGridColor(gridClip);
		}
		//changes clicked grid color
		private function fnChngClickGridColor(eve:MouseEvent):void{
			/*numTxt.text="";
			denTxt.text="";
			decimalTxt.text="";
			percent_mc.percentTxt.text="";*/
			
			var gridClip:MovieClip = eve.target as MovieClip;
			prevClip = null;
			stage.addEventListener(MouseEvent.MOUSE_MOVE, fnChngGridClrMouseMove);
			stage.addEventListener(MouseEvent.MOUSE_UP, fnRemoveGridEvents);
			var gridPos:Point = gridClip.parent.localToGlobal(new Point(gridClip.x, gridClip.y)); //converts movieclip local x/y position to global position
			var gridClipArr:Array = [];
			var clipNamArr:Array = [];
			var prevGrid:MovieClip;
			//Based on area clicked surrounding grid boxes are highlighted
			if(mouseX > 300 && mouseX < 682 && mouseY > 95 && mouseY < 478){//for changing color of 4 near by grids
				if((mouseX >= gridPos.x && mouseX <= gridPos.x + 5) && (mouseY >= (gridPos.y + 5) && mouseY <= (gridPos.y + gridClip.height - 5))){//highlight when cliked at bottom left
					clipNamArr = gridClip.name.split("_");
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1])-1)) as MovieClip;
					gridClipArr.push(prevGrid);
					
				}else if((mouseX <= gridPos.x + gridClip.width) && (mouseX >= gridPos.x + gridClip.width - 5) && (mouseY >= (gridPos.y + 5) && mouseY <= (gridPos.y + gridClip.height - 5))){//highlight when cliked at top right
					clipNamArr = gridClip.name.split("_");
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1])+1)) as MovieClip;
					gridClipArr.push(prevGrid);
				}else if((mouseX >= gridPos.x && mouseX <= gridPos.x + 5) && (mouseY > (gridPos.y + gridClip.height - 5) && mouseY <= (gridPos.y + gridClip.height ))){//highlight when cliked at bottom left
					clipNamArr = gridClip.name.split("_");
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1]) - 1)) as MovieClip;
					gridClipArr.push(prevGrid);
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1]) + 10)) as MovieClip;
					gridClipArr.push(prevGrid);
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1])+ 9)) as MovieClip;
					gridClipArr.push(prevGrid);
				}else if((mouseX <= (gridPos.x +  gridClip.width) && mouseX > (gridPos.x +  gridClip.width - 5)) && (mouseY > (gridPos.y + gridClip.height - 5) && mouseY <= (gridPos.y + gridClip.height ))){//highlight when cliked at bottom right
					clipNamArr = gridClip.name.split("_");
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1]) + 1)) as MovieClip;
					gridClipArr.push(prevGrid);
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1]) + 10)) as MovieClip;
					gridClipArr.push(prevGrid);
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1])+ 11)) as MovieClip;
					gridClipArr.push(prevGrid);
				}else if((mouseX <= (gridPos.x +  gridClip.width) && mouseX > (gridPos.x +  gridClip.width - 5)) && (mouseY <= (gridPos.y + 5) && mouseY >= (gridPos.y))){//highlight when cliked at top right
					clipNamArr = gridClip.name.split("_");
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1]) + 1)) as MovieClip;
					gridClipArr.push(prevGrid);
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1]) - 10)) as MovieClip;
					gridClipArr.push(prevGrid);
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1])- 9)) as MovieClip;
					gridClipArr.push(prevGrid);
				}else if((mouseX >= gridPos.x && mouseX <= (gridPos.x + 5)) && (mouseY <= (gridPos.y + 5) && mouseY >= (gridPos.y))){//highlight when cliked at top left
					clipNamArr = gridClip.name.split("_");
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1]) - 1)) as MovieClip;
					gridClipArr.push(prevGrid);
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1]) - 10)) as MovieClip;
					gridClipArr.push(prevGrid);
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1])- 11)) as MovieClip;
					gridClipArr.push(prevGrid);
				}
			}else{//for changing next/previous grid
				if((mouseX >= gridPos.x && mouseX <= gridPos.x + 5) && (mouseY >= (gridPos.y + 5) && mouseY <= (gridPos.y + gridClip.height - 5))){
					clipNamArr = gridClip.name.split("_");
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1])-1)) as MovieClip;
					gridClipArr.push(prevGrid);
					
				}else if((mouseX >= gridPos.x && mouseX <= gridPos.x + 5) && (mouseY < (gridPos.y + 5) && mouseY >= gridPos.y) && mouseX > 300){
					clipNamArr = gridClip.name.split("_");
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1])-1)) as MovieClip;
					gridClipArr.push(prevGrid);
				}else if((mouseX <= gridPos.x + gridClip.width) && (mouseX >= gridPos.x + gridClip.width - 5) && (mouseY >= (gridPos.y +  gridClip.height - 5) && mouseY <= (gridPos.y + gridClip.height))){
					clipNamArr = gridClip.name.split("_");
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1])+1)) as MovieClip;
					gridClipArr.push(prevGrid);
				}else if((mouseX <= (gridPos.x +  gridClip.width) && mouseX > (gridPos.x +  gridClip.width - 5)) && (mouseY <= (gridPos.y + 5) && mouseY >= (gridPos.y)) && mouseX < 682){
					clipNamArr = gridClip.name.split("_");
					prevGrid = gridsMC.getChildByName("gridBox_" + (Number(clipNamArr[1])+1)) as MovieClip;
					gridClipArr.push(prevGrid);
					
				}
			}
			gridClipArr.push(gridClip);
			for(var i:Number = 0; i < gridClipArr.length; i++){
				fnChangeGridColor(gridClipArr[i]);
			}
		}
		
		private function fnChngGridClrMouseMove(eve:MouseEvent):void{
			var gridClip:MovieClip = eve.target as MovieClip;
			if(String(gridClip) == "[object gridBoxMc]"){
				fnChangeGridColor(gridClip);
			}
		}
		
		private function fnRemoveGridEvents(eve:MouseEvent):void{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, fnChngGridClrMouseMove);
			stage.removeEventListener(MouseEvent.MOUSE_UP, fnRemoveGridEvents);
		}
		
		//changes the grid clicked or mouse move grid color
		private function fnChangeGridColor(clip:MovieClip):void{
			var totranscolr:uint;
			totranscolr = color;
			if(isDoubleClicked){
				if(color == clip.gridBoxBgMC.transform.colorTransform.color){
					clrShadGridCnt--;
					totranscolr = 0xffffff;
				}
				isDoubleClicked = false;
			}else if(clip.gridBoxBgMC.transform.colorTransform.color.toString(16) == "ffffff"){
				clrShadGridCnt++;
			}
			mcColorTransform = clip.transform.colorTransform;
			mcColorTransform.color = totranscolr;	
			clip.gridBoxBgMC.transform.colorTransform = mcColorTransform;
			prevClip = clip;
			fnValidate();
		}
		
		//Changes the grid color with the selected color
		private function fnChangeGridColorCode(eve:MouseEvent):void{
			var btnColor:Array = eve.target.name.split("_");
			color = uint(colorArr[btnColor[1]]);	
			//colorPalette_mc.highLight_mc.x = eve.target.x;
			//colorPalette_mc.highLight_mc.y = eve.target.y;
			
			for(var i:int=0;i<colorArr.length;i++)
			{
				var mc=colorPalette_mc.getChildByName("hi"+i);
				mc.visible=false;
			}
			mc=colorPalette_mc.getChildByName("hi"+btnColor[1]);
			mc.visible=true;
		}
		
		//validates when grid box is clicked and as well as in text field change
		private function fnValidate(eve:Event = null):void{
			var decimalVal:Number = clrShadGridCnt/100;
			var tickMC:*;
			var fractionFlag:Boolean = false;
			var decimalFlag:Boolean = false;
			var percentFlag:Boolean = false;
			if(tickMCs.getChildByName("tickMC_0") != null){
					tickMCs.removeChild(tickMCs.getChildByName("tickMC_0"));
			}
			if(tickMCs.getChildByName("tickMC_1") != null){
						tickMCs.removeChild(tickMCs.getChildByName("tickMC_1"));
					}
			if(tickMCs.getChildByName("tickMC_2") != null){
				tickMCs.removeChild(tickMCs.getChildByName("tickMC_2"));
			}
			var fraction:Number = clrShadGridCnt/100;
			var enteredFraction:Number = Number(numTxt.text)/Number(denTxt.text)
			if(fraction.toFixed(2) == enteredFraction.toFixed(2) && clrShadGridCnt > 0){
				fractionFlag = true;
				tickMC = new tick_mc;				
				tickMCs.addChild(tickMC);
				tickMC.name = "tickMC_0";
				tickMC.x = tickPosArr[0].split("_")[0];
				tickMC.y = tickPosArr[0].split("_")[1];
			}else{
				fractionFlag = false;
				if(enteredFraction > 0 && clrShadGridCnt > 0 && denTxt.text.length > 0){
					tickMC = new wrong_mc;
					tickMCs.addChild(tickMC);
					tickMC.name = "tickMC_0";
					tickMC.x = Number(tickPosArr[0].split("_")[0]) + 5;
					tickMC.y = tickPosArr[0].split("_")[1];
				}
			}
			
			if(decimalTxt.text != ""){
				if((decimalVal == Number(decimalTxt.text) || Number(decimalVal.toFixed(2)) == Number(decimalTxt.text)) && clrShadGridCnt > 0){
					decimalFlag = true;
					tickMC = new tick_mc;
					tickMCs.addChild(tickMC)
					tickMC.name = "tickMC_1"
					tickMC.x = tickPosArr[1].split("_")[0];
					tickMC.y = tickPosArr[1].split("_")[1];
				}else{
					decimalFlag = false;
					if(decimalTxt.text.length > 0 && clrShadGridCnt > 0){
						tickMC = new wrong_mc;
						tickMCs.addChild(tickMC)
						tickMC.name = "tickMC_1"
						tickMC.x = Number(tickPosArr[1].split("_")[0]) + 5;
						tickMC.y = tickPosArr[1].split("_")[1];
					}
				}
			}
			else{
					decimalFlag = false;					
			}
			if(Number(percent_mc.percentTxt.text) == clrShadGridCnt && percent_mc.percentTxt.text != "" && clrShadGridCnt > 0){
				percentFlag = true;
				tickMC = new tick_mc;
				tickMCs.addChild(tickMC);
				tickMC.name = "tickMC_2"
				tickMC.x = tickPosArr[2].split("_")[0];
				tickMC.y = tickPosArr[2].split("_")[1];
			}else{
				percentFlag = false;
				if(percent_mc.percentTxt.text.length > 0 && clrShadGridCnt > 0){
					tickMC = new wrong_mc;
					tickMCs.addChild(tickMC)
					tickMC.name = "tickMC_2"
					tickMC.x = Number(tickPosArr[2].split("_")[0]) + 5;
					tickMC.y = tickPosArr[2].split("_")[1];
				}
			}
			//if(clrShadGridCnt == Number(numTxt.text) && (decimalVal == Number(decimalTxt.text) || Number(decimalVal.toFixed(2)) == Number(decimalTxt.text)) && Number(denTxt.text) == 100){
			if((clrShadGridCnt && decimalFlag)){
				if(!percent_mc.visible){
					fnAddRemoveGreatMC(true);
				}else if(percent_mc.visible && percentFlag){					
					fnAddRemoveGreatMC(true);
				}else{					
					fnAddRemoveGreatMC(false);
				}
			}else{
				fnAddRemoveGreatMC(false);
			}
		}
		
		//show/hides percentage box
		private function fnShowHidePercentage(eve:MouseEvent):void{
			var clip:MovieClip = hidePercentBtn;
			var flag:Boolean;
			if(clip.showPerTxt_mc.visible){
				flag = true;
				clip.showPerTxt_mc.visible = false;
				clip.hidePerTxt_mc.visible = true;
			}else{
				if(tickMCs.getChildByName("tickMC_2") != null){
					tickMCs.removeChild(tickMCs.getChildByName("tickMC_2"));
				}
				flag = false;
				clip.showPerTxt_mc.visible = true;
				clip.hidePerTxt_mc.visible = false;
			}
			//percent_mc.percentTxt.text = "";
			percent_mc.visible = flag;
			if(percent_mc.visible){
				fnAddRemoveGreatMC(false);
			}
			if(!percent_mc.visible && clrShadGridCnt == Number(numTxt.text) && clrShadGridCnt > 0){
				fnAddRemoveGreatMC(true);
			}
		}
		
		//show/hides numbers inside grids
		private function fnShowNoInGrid(eve:MouseEvent):void{
			//var clip:MovieClip = showNoBtn;
			var clip:MovieClip = eve.currentTarget as MovieClip;
			var flag:Boolean;
			if(clip.showNoTxt_mc.visible){
				flag = true;
				clip.showNoTxt_mc.visible = false;
				clip.hideNoTxt_mc.visible = true;
			}else{
				flag = false;
				clip.showNoTxt_mc.visible = true;
				clip.hideNoTxt_mc.visible = false;
			}
			for(var i:Number = 1; i <= count; i++){
				MovieClip(gridsMC.getChildByName("gridBox_" + i)).numberTxt.visible = flag;
			}
		}
		
		//generates some random number and shades based on random number
		private function fnRandomShadeGrid(eve:MouseEvent):void{
			fnFillGridBox(count, 0xffffff);
			fnAddRemoveGreatMC(false);
			fnRemoveTicks();
			clrShadGridCnt = Math.ceil(Math.random() * 100);
			/*if(color == 0xffffff){
				color = 0xffff00
				//colorPalette_mc.highLight_mc.x = colorPalette_mc.clr_2_mc.x;
				//colorPalette_mc.highLight_mc.y = colorPalette_mc.clr_2_mc.y;
				for(var i:int=0;i<colorArr.length;i++)
				{
					var mc=colorPalette_mc.getChildByName("hi"+i);
					mc.visible=false;
				}
				mc=colorPalette_mc.getChildByName("hi2");
				mc.visible=true;
			}*/
			fnFillGridBox(clrShadGridCnt, color);
			fnResetTextFields();
		}
		
		//Generates grid color with the numerator entered under fraction
		private function fnAutoShadeGrid(eve:MouseEvent):void{
			clrShadGridCnt = Number(numTxt.text);
			if(denTxt.text != "")
			{
				denTxt.text="100";
			}
			if(denTxt.text != "" && Number(denTxt.text) == 100){//checks if the denominator is null
				fnFillGridBox(count, 0xffffff);
				fnFillGridBox(clrShadGridCnt, color);
				fnAddRemoveGreatMC(true);
				var decimalVal:Number = Number(numTxt.text)/100;
				if(decimalVal < 1){
					decimalTxt.text = decimalVal.toFixed(2);
				}else{
					decimalTxt.text = String(decimalVal);
				}
				if(percent_mc.visible){
					percent_mc.percentTxt.text = numTxt.text;
				}
				for(var i:Number = 0; i < tickPosArr.length; i++){
					var tickMC:tick_mc = new tick_mc;
					if(i==2 && !hidePercentBtn.hidePerTxt_mc.visible)
					{
						break;
					}
					tickMCs.addChild(tickMC);
					tickMC.name = "tickMC_" + i;
					tickMC.x = tickPosArr[i].split("_")[0];
					tickMC.y = tickPosArr[i].split("_")[1];
				}
			}
		}
		
		//fills grid box for specified no of boxes
		private function fnFillGridBox(cnt:Number, clr:uint):void{
			for(var i:Number = 1; i <= cnt; i++){				
				var gridClip:MovieClip = gridsMC.getChildByName("gridBox_" + i) as MovieClip;				
				mcColorTransform = gridClip.transform.colorTransform;
				mcColorTransform.color = clr;	
				gridClip.gridBoxBgMC.transform.colorTransform = mcColorTransform;
			}
		}
		
		//shows/hides great mc
		private function fnAddRemoveGreatMC(flag:Boolean):void{
			var greatMC:MovieClip;
			if(getChildByName("greatMC") != null){
				removeChild(getChildByName("greatMC"));
			}
			if(flag){
				greatMC = new great_mc;
				addChild(greatMC);
				greatMC.name = "greatMC";
				greatMC.x = (stageWidth/2)+50;
				greatMC.y = -10
			}
		}
		
		//resets text field
		private function fnResetTextFields():void{
			numTxt.text = "";
			denTxt.text = "";
			decimalTxt.text = "";
			percent_mc.percentTxt.text = "";
		}
		
		private function fnRemoveTicks():void{
			for(var i:Number = tickMCs.numChildren-1; i >= 0; i--){
				tickMCs.removeChild(tickMCs.getChildAt(i));
			}
		}
		
		//reset
		private function reset(eve:MouseEvent):void{
			color = colorArr[2];
			clrShadGridCnt = 0;
			fnRemoveTicks();
			fnFillGridBox(count, 0xffffff);
			//colorPalette_mc.highLight_mc.x = colorPalette_mc.clr_2_mc.x;
			//colorPalette_mc.highLight_mc.y = colorPalette_mc.clr_2_mc.y;
			for(var i:int=0;i<colorArr.length;i++)
			{
				var mc=colorPalette_mc.getChildByName("hi"+i);
				mc.visible=false;
			}
			mc=colorPalette_mc.getChildByName("hi2");
			mc.visible=true;
			
			fnResetTextFields();
			fnAddRemoveGreatMC(false);
		}
		
	}
}