﻿package {
	
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	import flash.events.MouseEvent;
	import fl.transitions.Tween;
	import fl.transitions.easing.*;
	import flash.geom.Rectangle;
	import flash.geom.ColorTransform;
	import flash.ui.Mouse;
	
	//import com.Notes;
	
	public class Grid extends MovieClip {
		
		var changeFlag = true;
		var colorArray:Array = ["", 0x029801, 0xFF0000, 0xFEFF00, 0x04459F, 0x000000];
		var colorNumber = 5;
		//var lineMultiArray = new Array();
		
		var lineArray:Array = [];
		var lineObject:Array = [];
		
		var curDotObject ;
		var preDotObject ;
		
		var ySpace = 50;
		var placeMc;
		var placeMc1;
		var dotMc;
		var lineMc;
		var objectArray:Array;
		var dotArray:Array = [];
		var boxArray:Array = [];
		var lineCont = new Sprite();
		
		var rcount = 20, ccount = 20;
		var labArr = [ '–10', '–9', '–8', '–7', '–6', '–5', '–4', '–3', '–2', '–1', 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
		var revlabarr = [ 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0, '–1', '–2', '–3', '–4', '–5', '–6', '–7', '–8', '–9', '–10'];
		
		
		var indArr = [ -10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
		var alpArr = [  '–K', '–J', '–I', '–H', '–G', '–F', '–E', '–D', '–C', '–B', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K'];
		
		
		
		var numeric;
		
		
		public function Grid() {
			addEventFunctions();
		}
		
		function addEventFunctions() {
			
			numeric = true;
			lineCont = new Sprite();
			
			var gmc = new MovieClip();
			gmc.name = "gmc";
			generateField(rcount, ccount, gmc);
			generateLine(rcount+1, ccount+1, gmc);
			generateDot(rcount+1, ccount+1, gmc);
			addChild(gmc);
			
			
			gmc.scaleX = 0.68;
			gmc.scaleY = 0.68;
			gmc.x = 100;
			gmc.y = -25;
			
			changeEnable(true);
			changeEnableBox(false);
			//cursorMc.visible = false;
			dmy.addEventListener(MouseEvent.CLICK, removeSelection);
			reset_btn.addEventListener(MouseEvent.CLICK, resetSelection);
			
			negative_h.addEventListener(MouseEvent.CLICK, onActionFunction )
			negative_s.addEventListener(MouseEvent.CLICK, onActionFunction )
			points_h.addEventListener(MouseEvent.CLICK, onActionFunction )
			points_s.addEventListener(MouseEvent.CLICK, onActionFunction )
			lines_h.addEventListener(MouseEvent.CLICK, onActionFunction )
			lines_s.addEventListener(MouseEvent.CLICK, onActionFunction )
			horibtn.addEventListener(MouseEvent.CLICK, changeNumber);
			
			negative_h.dispatchEvent(new Event(MouseEvent.CLICK));
			horibtn.dispatchEvent(new Event(MouseEvent.CLICK));
		}
		
		
		
		function onActionFunction(eve) {
			
			var targName = eve.target.name;
			var targ = eve.target;
			var gmc:MovieClip = MovieClip(getChildByName("gmc"));
			
			switch (targName) 
			{
				case "negative_h":
					 gmc.scaleX = 1;
					 gmc.scaleY = 1;
					 
					 _maksmc.visible = true;
					 gmc.mask = _maksmc;
					 
					 negative_h.visible = false;
					gmc.x = -200;
					 
				break;
				case "negative_s":
					 gmc.scaleX = 0.68;
					 gmc.scaleY = 0.68;
					 
					 _maksmc.visible = false;
					 gmc.mask = null;
					 
					 
					 negative_h.visible = true;
					 gmc.x = 100;
					 
				break;
				case "points_h":
					for (var i:uint = 1; i < dotArray.length; i++) {
						dotArray[i]._txt.visible=0
					}
					points_h.visible = false;
				break;
				case "points_s":
					for (var i:uint = 1; i < dotArray.length; i++) {
						dotArray[i]._txt.visible=1
					}
					points_h.visible = true;
				break;
				case "lines_h":
					lineCont.visible = false;
					lines_h.visible = false;
				break;
				case "lines_s":
					lineCont.visible = true;
					lines_h.visible = true;
				break;
				
				
				default:
			}
			
			
		}
		
		
		function changeNumber(e):void {
			var gmc = MovieClip(getChildByName("gmc"));
			
			var alpmc = gmc.getChildByName("alpmc");
			var nummc = gmc.getChildByName("nummc");
			
			var lablr_0_x = nummc.getChildByName("lablr_0_x");
			var lablr_0_y = gmc.getChildByName("lablr_0_y");
			
			if (!numeric) {
				alpmc.visible = true;
				nummc.visible = false;
				for (var i:uint = 1; i <= rcount+1; i++) {
					for (var j:uint = 1; j <= ccount+1; j++) {
						var dotMc=gmc.getChildByName("dot_" + i + "_" + j);
						//dotMc._txt.text =  "(" + alpArr[j-1] + ", " + (-1*indArr[i-1]) + ")";
						dotMc._txt.text =  "(" + alpArr[j-1] + ", " + (revlabarr[i-1]) + ")";
						
						//trace(dotMc.name, "(" + alpArr[j-1] + ", " + (revlabarr[i-1]) + ")")
					}
				}
				
				
				
				lablr_0_x.visible = false;
				lablr_0_y.visible = false;
				
			}else {
				alpmc.visible = false;
				nummc.visible = true;
				lablr_0_x.visible = true;
				lablr_0_y.visible = true;
				for (var i:uint = 1; i <= rcount; i++) {
					for (var j:uint = 1; j <= ccount; j++) {
						var dotMc=gmc.getChildByName("dot_" + i + "_" + j);
						//dotMc._txt.text =  "(" + labArr[j-1] + ", " + (-1*indArr[i-1]) + ")";
						dotMc._txt.text =  "(" + labArr[j-1] + ", " + (revlabarr[i-1]) + ")";
					}
				}
			}
			
			numeric = !numeric;
			
			trace("changeNumber", gmc.name);
		}
		

		function resetSelection(eve):void 
		{
			removeSelection(eve);
			removeChild(getChildByName("gmc"));
			addEventFunctions();
		}
		
		
		function removeSelection(e:MouseEvent):void {
			preDotObject = "";
			resetDot();
		}
		
		function generateField(row, col, targt):void {
			for (var i:uint = 1; i <= row; i++) {
				for (var j:uint = 1; j <= col; j++) {
					placeMc = new placeHolder();
					placeMc.name = "backBox_" + i + "_" + j;
					targt.addChild(placeMc);
					placeMc.x = 25 + (placeMc.width) * j;
					placeMc.y = 25 + (placeMc.height) * i;
					
				}
			}
		}
		
		
		
		function generateDot(row, col, targt):void {
			for (var i:uint = 1; i <= row; i++) {
				for (var j:uint = 1; j <= col; j++) {
					dotMc = new dotHolder();
					dotArray.push(dotMc);
					dotMc.name = "dot_" + i + "_" + j;
					dotMc.alpha = 0;
					dotMc.stat = 1;
					dotMc.sel = false;
					targt.addChild(dotMc);
					//dotMc._txt.text =  "(" + labArr[j - 1] + "," + (revlabarr[i - 1]) + ")";
					dotMc._txt.text =  "(" + indArr[j-1] + "," + (-1*indArr[i-1]) + ")";
					dotMc._txt.mouseEnabled = false;
					dotMc._txt.visible = false;
					dotMc.x = 8 + (placeMc.width) * j;
					dotMc.y = 8 + (placeMc.height) * i;
					dotMc.buttonMode = true;
					dotMc.addEventListener(MouseEvent.CLICK, onPressDot);
				}
			}
		
		}
		 
		function resetDot(obt = null):void {
			//trace("> " + obt);
			for (var i = 0; i < dotArray.length; i++) {
				if (dotArray[i] != obt) {
					dotArray[i].gotoAndStop(1);
				}
			}
		}

		function onPressDot(e:MouseEvent):void {
			resetDot(e.target);
			//trace(e.target.name);
			curDotObject = e.target;
			if (e.target.alpha == 0) {
				e.target.gotoAndStop(2);
				e.target.alpha = 1;
				e.target._txt.visible = true;
				showLine();
				preDotObject = e.target;
			} else if (e.target.alpha == 1 && e.target.currentFrame == 1) {
				e.target.gotoAndStop(2);
				showLine();
				preDotObject = e.target;
			} else if (e.target.alpha == 1 && e.target.currentFrame == 2) {
				e.target.alpha = 0;
				preDotObject = null;
			}
			
			
			e.target._txt.visible = points_h.visible;
			
			
			
			
			
		}
		
		function showLine():void {
			if(curDotObject && preDotObject)
			{
				
				//var gmc:MovieClip = MovieClip(getChildByName("gmc"));
				
				var curX = curDotObject.name.split("_")[1];
				var curY = curDotObject.name.split("_")[2];
				
				var preX = preDotObject.name.split("_")[1];
				var preY = preDotObject.name.split("_")[2];
				
				var slp = (preY - curY) / (preX - curX);

				var colr = colorArray[colorNumber];
				
				if (preX == curX){
					addLineSeg(preDotObject, curDotObject, colr);
				}
				if(preY == curY){
					addLineSeg(preDotObject, curDotObject, colr);
				}
				if (slp == 1 || slp == -1) {
					addLineSeg(preDotObject, curDotObject, colr);
				}
				
			}
		}
		
		function addLineSeg(_pre, _cur, colr) {
			var tline = new Sprite();
			lineCont.addChild(tline);
			tline.addEventListener(MouseEvent.CLICK, removeLine);
			tline.graphics.lineStyle(2, colr);
			tline.graphics.moveTo(_pre.x, _pre.y);
			tline.graphics.lineTo(_cur.x, _cur.y);
			tline.buttonMode = true;
		}
		function removeLine(eve):void 
		{
			var targ = eve.target;
			lineCont.removeChild(targ);
		}
		function generateLine(row, col, targt):void {
			
			
			var placeMc = new placeHolder()
			
			var alpmc = new Sprite(), nummc = new Sprite();
			
			var slashlr = new labtxt();
			slashlr._txt.text = "0/";
			alpmc.addChild(slashlr);
			
			for (var j:uint = 1; j <= ccount + 1; j++) {
				
				var lablr = new labtxt();
				lablr._txt.text = alpArr[j-1];
				alpmc.addChild(lablr);
				
				
				lablr.x= -20+ (placeMc.width) * j
				lablr.y = 395
				
				
				if (j == 11) {
					//lablr.x = -32 + (placeMc.width) * j
					slashlr.x = -27 + (placeMc.width) * j
					slashlr.y = 395
				}
				
				
			}
			alpmc.name = "alpmc";
			targt.addChild(alpmc);
			
			
			for (var j:uint = 1; j <= ccount + 1; j++) { 
				
				var lablr = new labtxt();
				lablr._txt.text =  labArr[j-1] //String(j-11);
				nummc.addChild(lablr);
				lablr.x= -20+ (placeMc.width) * j
				lablr.y = 395
				lablr.selectable = false;
				
				if (j == 11) {
					lablr.name = "lablr_0_x";
				}
			}
			nummc.name = "nummc";
			targt.addChild(nummc);			
			
			
			for (var i:uint = 1; i <= rcount + 1; i++) {
				var lablr = new labtxt();
				lablr._txt.text =  labArr[i-1] //String(i-11);
				targt.addChild(lablr);
				lablr.y= 10+(placeMc.height*22) - (placeMc.height) * i
				lablr.x = 365
				lablr.selectable = false;
				
				if (i == 11) {
					lablr.name = "lablr_0_y";
				}
			}
			
			
			targt.addChild(lineCont);
			
		
		}
		
		function offLine(e:MouseEvent):void {
			e.target.visible = false;
		}
		
		function changeEnable(enb:Boolean):void {
			for (var i = 0; i < lineObject.length; i++) {
				lineObject[i].mouseEnabled = enb;
				lineObject[i].rowLine.mouseEnabled = enb;
				lineObject[i].colLine.mouseEnabled = enb;
				
			}
			for (var j = 0; j < dotArray.length; j++) {
				dotArray[j].mouseEnabled = enb;
				
			}
		}
		
		function changeEnableBox(enb:Boolean):void {
			for (var j = 0; j < boxArray.length; j++) {
				boxArray[j].mouseEnabled = enb;
			}
		}

		function follow(evt:MouseEvent) {
			//cursorMc.x = mouseX;
			//cursorMc.y = mouseY;
		}
	
	}
}